include:
  - remote: 'https://gitlab.com/systra/qeto/infra/gitlab-ci-templates/raw/master/security-ci.yml'
  - remote: 'https://gitlab.com/systra/qeto/infra/gitlab-ci-templates/raw/master/secret-ci.yml'
  - remote: 'https://gitlab.com/systra/qeto/infra/gitlab-ci-templates/raw/master/linter-ci.yml'
  - remote: 'https://gitlab.com/systra/qeto/infra/gitlab-ci-templates/raw/master/type-checker-ci.yml'
  - remote: 'https://gitlab.com/systra/qeto/infra/gitlab-ci-templates/raw/master/tag-ci.yml'
  - remote: 'https://gitlab.com/systra/qeto/infra/gitlab-ci-templates/raw/master/publish-ci.yml'
stages:
  - test
  - release
  - publish
variables:
  VERSION_UPDATE:
    description: "Should be set to either major, minor or patch"
security:
  extends: .security
secret:
  extends: .secret
linter:
  extends: .linter_py310
type_checker:
  extends: .type_checker_py310
  script:
    - 'mkdir -p reports'
    - 'poetry run mypy | tee reports/mypy.log'
.tag_base:
  extends: .tag_python
  needs:
    - security
    - secret
    - linter
    - type_checker
tag:major:
  extends: .tag_base
tag:minor:
  extends: .tag_base
tag:patch:
  extends: .tag_base
publish:
  extends: .publish
  variables:
    DOCKER_DIR: "build"
image_security:
  extends: .image_security
  needs:
    - publish
